* Ŀ
*  PROGRAM: dbmaker.prg                                                   
* Ĵ
*  Purpose: writes the code to create a dbf, given the dbf itself         
*                                                                         
*   Author: Arthur Fuller, Artful Applications Inc. 1990                  
*                                                                         
* Ĵ
*  NOTES:                                                                 
* Ĵ
*  Sometimes you want your program to be able to create any of its data   
*  files automatically, in their absence. This program writes the code    
*  to create any dbf. You need a copy of the dbf to make it work.         
*                                                                         
*  Syntax: dbmaker <dbf_file> [<output_text_file>]                        
*                                                                         
*  You gotta pass dbf_file. If you don't pass param 2 I make up up        
*  taking the first 4 letters of your dbf and appending "make.prg" to it. 
*                                                                         
* 
*  


* writes the code to create a file
PARAMETERS _dbf, _outfile
IF TYPE( "_outfile" ) != "C"
   _outfile = LEFT( _dbf, 4 ) + "MAKE.PRG"
ENDIF
IF TYPE( "_dbf" ) != "C"
   ? "Usage: dbmaker <dbf_file> [<output_text_file>]"
   QUIT
ENDIF
IF !DB_OPEN( _dbf )
   SET CURSOR ON
   QUIT
ENDIF

_outfile = LEFT( _dbf, 4 ) + "MAKE.PRG"
_fSize   = FCOUNT()
DECLARE _fields[ _fSize ], _types[ _fSize ], _lengths[ _fSize ], ;
        _decs[ _fSize ]
AFIELDS( _fields, _types, _lengths, _decs )

SET ALTERNATE TO (_outfile)
SET ALTERNATE ON
? 'CREATE _tmpfile'
FOR i = 1 TO _fSize
    ? 'APPEND BLANK'
    ? 'REPLACE Field_Name WITH "'+ _fields[ i ]+ '", ;'
    ? '        Field_Type WITH "'+ _types[ i ]+ '", ;'
    ? '        Field_Len  WITH '+ STRINT(_lengths[ i ])+ ', ;'
    ? '        Field_Dec  WITH '+ STRINT(_decs[ i ])
NEXT
? 'USE'
? 'CREATE ' + _dbf + ' FROM _tmpfile'
?
SET ALTERNATE OFF
SET ALTERNATE TO
SET CURSOR ON
QUIT

